import java.net.*;
import java.io.*;
import java.awt.*;
import java.awt.event.*;

public class DataConnection implements Runnable
{
 private static BufferedInputStream in;
 private static BufferedOutputStream out;
 private Thread reciever;
 private int port = 6666;
 private Socket sock = null;
 private String type;
 private String file;
 private String host;
 public boolean finished = false;
 public boolean isThere = false;

public DataConnection(int port, String host, String file, String type)
{
  this.file = file;
  this.host = host;
  this.port = port;
  this.type = type;
  reciever = new Thread(this);
  reciever.start();
}

public void run()
{

 try
  {
  boolean ok = true;

  try {sock = new Socket(host,port);}
  catch(Exception ex) {ok = false; debugWrite("Can't open Socket on port "+port);}

  if(ok)
  {
   isThere = true;
//   debugWrite("Opened Dataconnection...");

   if(type.equals("RECV"))
   {
    BufferedOutputStream fOut = null;
    try {fOut = new BufferedOutputStream(new FileOutputStream(file));}
    catch(Exception ex) {debugWrite("Can't create outputfile!");}

    if(ok)
    {
     try {in = new BufferedInputStream(sock.getInputStream());}
     catch(Exception ex) {ok = false; debugWrite("Can't get InputStream"); }

     if(ok)
     {

      try
      {
//       int len = 0;
       char b;

       while(true)
       {
        b = (char) in.read();
//        len++;
        Character c = new Character(b);
        if(c.hashCode() == 65535) break;

        fOut.write(b);
        if(b == StreamTokenizer.TT_EOF) {break;}
       }
       fOut.flush();
       fOut.close();

//       System.out.println("length: "+len);
      }
      catch(IOException ex) {ok = false; debugWrite("IOException!");}
     }
    }
   }

   if(type.equals("SEND"))
   {
    BufferedInputStream fIn = null;
    try {fIn = new BufferedInputStream(new FileInputStream(file));}
    catch(Exception ex) {debugWrite("Can't open inputfile!");}

    if(ok)
    {
     try {out = new BufferedOutputStream(sock.getOutputStream());}
     catch(Exception ex) {ok = false; debugWrite("Can't get OutputStream"); }

     if(ok)
     {

      try
      {
//       int len = 0;
       char b;

       while(true)
       {
        b = (char) fIn.read();
//        len++;
        Character c = new Character(b);
        if(c.hashCode() == 65535) break;

        out.write(b);
        if(b == StreamTokenizer.TT_EOF) {break;}
       }
       out.flush();
       fIn.close();

      }
      catch(IOException ex) {ok = false; debugWrite("IOException!");}
     }
    }
   }

  }
 }
 catch(Exception ex) {debugWrite(ex.toString());}

 try {sock.close();}
 catch(Exception ex) {debugWrite(ex.toString());}

 finished = true;
}

public static void main(String argv[])
{
 DataConnection dcon = new DataConnection(Integer.parseInt(argv[0]),"localhost","tmpxxx","RECV");
}

private void debugWrite(String msg)
{
 JFtp.debugWrite(msg);
}

public void reset()
{
 reciever.destroy();
 reciever = new Thread(this);
 reciever.start();
}

private void pause(int time)
{
try {reciever.sleep(time);}
catch(Exception ex) {System.out.println(ex);}
}

}
