import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class DirEntry extends Canvas implements MouseListener, ActionListener
{
 public String file = "";
 private PopupMenu pop = new PopupMenu("Action");
 private MenuItem delete = new MenuItem("remove");
 private MenuItem upload = new MenuItem("upload");
 private MenuItem download = new MenuItem("download");
 private MenuItem change = new MenuItem("goto");
 private MenuItem prefs = new MenuItem("properties");
 private MenuItem view = new MenuItem("view");

 public boolean selected = false;
 public ActionListener who = null;

 private int xpos = 35;
 private int ypos = 15;
 private boolean entered = false;
 private Color back = Settings.back;
 private Color front = Settings.front;
 private Font font = Settings.font;
 private Image img;
 private boolean isFile = true;
 private boolean isKb = true;
 private boolean isDirectory = false;
 public int size = 0;

public DirEntry(String file, ActionListener who)
{
 this.file = file;
 this.who = who;

 img = HImage.getImage(this,Settings.fileImage);

 addMouseListener(this);
 add(pop);

 setFile();
 setVisible(true);
}

public void paint(Graphics g)
{
 g.setColor(back);
 g.fillRect(0,0,getSize().width,getSize().height);
 g.setColor(front);
 g.setFont(font);
 g.drawImage(img,10,0,this);
 g.drawString(file,xpos,ypos);

if(!isDirectory)
{
 g.setColor(Settings.sizeBack);
 g.fillRect(getSize().width-75,getSize().height-20,getSize().width,getSize().height);
 g.setColor(Settings.front);
 String tmp = " bytes";
 if(isKb) {tmp = " kb";}
 g.drawString(Integer.toString(size)+tmp,getSize().width-73,ypos);
}

}

public void update(Graphics g)
{
 paint(g);
}

public void mouseClicked(MouseEvent e) {}
public void mousePressed(MouseEvent e) { if(e.isPopupTrigger()) {pop.show(this,10,10);}}

public void mouseReleased(MouseEvent e)
{

 if(isFile)
 {
  if(selected)
  {
   selected = false;
   front = Settings.front;
  }
  else
  {
   selected = true;
   front = Settings.activatedColor;
  }
 }

 else if(isDirectory)
 {
  who.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,file));
 }

 repaint();
}

public void mouseEntered(MouseEvent e)
{
 entered = true;
 setCursor(new Cursor(Cursor.HAND_CURSOR));
// font = Settings.active;
 back = Settings.activeColor;
 repaint();
}

public void mouseExited(MouseEvent e)
{
 entered = false;
 setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
// font = Settings.font;
 back = Settings.back;
 repaint();
}

public void setFile()
{
 img = HImage.getImage(this,Settings.fileImage);
 isFile = true;
 isDirectory = false;

if(((DirPanel) who).type.equals("local"))
{
 try
 {
//  System.out.println((((DirPanel) who).path)+file);
  File f = new File((((DirPanel) who).path)+file);

  if(f.exists())
  {
   size = (int) f.length();
  }
 }
 catch(Exception ex) {}
}

 if(size > 1000)
 {
  size = size/1000;
  isKb = true;
 }
 else {isKb = false;}


 setPopup();
 repaint();
}

private void setPopup()
{
 delete.removeActionListener(this);
 upload.removeActionListener(this);
 download.removeActionListener(this);
 change.removeActionListener(this);
 prefs.removeActionListener(this);
 pop.removeAll();

 if(((DirPanel) who).type.equals("local"))
 {
  pop.add(upload);
  upload.addActionListener(this);
 }

 if(((DirPanel) who).type.equals("remote"))
 {
  pop.add(download);
  download.addActionListener(this);
 }

 if(isDirectory)
 {
  pop.add(change);
  change.addActionListener(this);
 }

 if(isFile)
 {
  pop.add(prefs);
  prefs.addActionListener(this);
 }

 if(isFile && ((DirPanel) who).type.equals("local"))
 {
  pop.add(view);
  view.addActionListener(this);
 }

 pop.add(delete);
 delete.addActionListener(this);
}

public void actionPerformed(ActionEvent e)
{
 DirPanel p = ((DirPanel) who);
 if(e.getSource() == delete) {RemoverQuery armv = new RemoverQuery(file, p.type);}

 if(e.getSource() == upload && !isDirectory) {Resource.upload(file);}
 if(e.getSource() == download && !isDirectory) {Resource.download(file);}

 if(e.getSource() == upload && isDirectory) {Resource.uploadDir(file,((DirPanel) who).path);}
 if(e.getSource() == download && isDirectory) {Resource.downloadDir(file,((DirPanel) who).path);}

 if(e.getSource() == prefs) {Properties prps = new Properties(file,p.type);}

 if(e.getSource() == view)
 {
  if(size < 1500) {Displayer d = new Displayer(((DirPanel) who).path+file);}
 }

 if(e.getSource() == change)
 {
  if(!file.equals(".."))
  {
   if(p.type.equals("local")) {p.setPath(p.path +file);}
   if(p.type.equals("remote")) {p.setRemotePath(p.path +file);}
  }
 }
}

public void setDirectory()
{
 img = HImage.getImage(this,Settings.dirImage);
 isFile = false;
 isDirectory = true;
 setPopup();
 repaint();
}

}