import java.io.*;
import java.net.*;
import java.awt.event.*;

public class DirLister implements ActionListener
{
 private String path;
 private String type;
 private int length;
 private String[] files;
 private String[] sizes;
 private boolean isDirectory = true;
 public boolean finished = false;

public DirLister(String path, String type)
{
 this.path = path;
 this.type = type;
 if(type.equals("local")) {localInit();}
 else if(type.equals("remote")) {remoteInit();}
}

private void localInit()
{
 File dir = new File(path);

 if(dir.isDirectory())
 {
  files = dir.list();
  length = Resource.getLength(files);
 }
 else {isDirectory = false;}

 finished = true;
}

public void remoteInit()
{
 isDirectory = true;

 try
 {
  DataInputStream in = new DataInputStream(FtpConnection.jcon.getInetInputStream());

  FtpConnection.jcon.send("PASV");
  String tmp = Resource.getLine("227");
  int port = Resource.getPasvPort(tmp);
//  System.out.println("port: "+port);
  FtpConnection.jcon.send("MODE S");
  Resource.getLine("200");
  FtpConnection.jcon.send("TYPE I");
  Resource.getLine("200");
  DataConnection dcon = new DataConnection(port,JFtp.getHost(),"cfg/.ls_out","RECV");
  while(!dcon.isThere) Resource.pause(100);
  FtpConnection.jcon.send("LIST");
  while(!dcon.finished) Resource.pause(100);
  Resource.getLine("226");
  files = Resource.sortLs("cfg/.ls_out");
  sizes = Resource.sortSize("cfg/.ls_out");
//  System.out.println(Resource.getLength(sizes));
  length = Resource.getLength(files);
//  System.out.println("length: "+length);
 }
 catch(Exception ex) {JFtp.debugWrite(ex.toString() +" @DirLister::remoteInit()"); isDirectory = false;}

 finished = true;
}

public void actionPerformed(ActionEvent e) {}

public boolean isOk()
{
 return isDirectory;
}

public int getLength()
{
 return length;
}

public String[] list()
{
 return files;
}

public String[] sList()
{
 if(type.equals("local")) {return null;}
 else return sizes;
}

}