import java.awt.*;
import java.awt.event.*;
import java.io.*;

public class DirPanel extends HPanel implements ActionListener
{
 private HButton scrollUp = new HButton("up");
 private HButton scrollDown = new HButton("down");

 private HButton delete = new HButton("rm");
 private HButton mkdir = new HButton("mkdir");
 private HButton rmdir = new HButton("rmdir");
 private HButton cmd = new HButton("cmd");
 private HButton refresh = new HButton("fresh");
 private HButton cd = new HButton("cd");

// private HButton change = new HButton("Change");

 public DirEntry[] dirEntry;
 public String path = "./";
 public int length = 0;
 public String[] files;

 private int pos = 0;
 private Label label = new Label("Dir: ");
 private boolean pathChanged = true;
 private int w,h;
 private HPanel p = new HPanel();
 public String type = null;

public DirPanel(String path,int w, int h, String type)
{
 this.path = path;
 this.w = w;
 this.h = h;
 this.type = type;

 setSize(w,h);
 setLayout(null);

 if(!type.equals("remote")) setPath(path);
}

public void gui()
{
 setVisible(false);
 remove(p);

 p = new HPanel();
 p.setLayout(null);
 p.setSize(w,h);

 p.add(label);
 label.setBounds(0,0,getSize().width-80,20);
 label.setText("Dir: "+cutPath(path));
 label.setBackground(Settings.back);
 label.setForeground(Settings.front);
 label.setFont(Settings.menuFont);

// add(change);
// change.setBounds(getSize().width-80,0,80,20);
// change.addActionListener(this);

 p.add(delete);
 delete.setFont(Settings.small);
 delete.setBounds(0,20,40,20);
 delete.addActionListener(this);

 p.add(mkdir);
 mkdir.setFont(Settings.small);
 mkdir.setBounds(40,20,40,20);
 mkdir.addActionListener(this);

 p.add(rmdir);
 rmdir.setFont(Settings.small);
 rmdir.setBounds(80,20,40,20);
 rmdir.addActionListener(this);

 p.add(refresh);
 refresh.setFont(Settings.small);
 refresh.setBounds(120,20,40,20);
 refresh.addActionListener(this);

 p.add(cd);
 cd.setFont(Settings.small);
 cd.setBounds(160,20,40,20);
 cd.addActionListener(this);

if(type.equals("remote"))
{
 p.add(cmd);
 cmd.setFont(Settings.small);
 cmd.setBounds(200,20,40,20);
 cmd.addActionListener(this);
}

 p.add(scrollUp);
 scrollUp.setFont(Settings.small);
 scrollUp.setBounds(getSize().width-40,20,40,20);
 scrollUp.addActionListener(this);

 p.add(scrollDown);
 scrollDown.setFont(Settings.small);
 scrollDown.setBounds(getSize().width-40,getSize().height-20,40,20);
 scrollDown.addActionListener(this);

 DirEntry dwn = new DirEntry("..",this);
 dwn.setDirectory();
 p.add(dwn);
 dwn.setBounds(0,40,getSize().width,25);

// directory init

if(pathChanged)
{
 DirLister dir = new DirLister(path,type);
 while(!dir.finished) Resource.pause(100);

 if(dir.isOk())
 {
  length = dir.getLength();
  dirEntry = new DirEntry[length];
  files = dir.list();
  String fSize[] = dir.sList();

//  System.out.println("Len: "+Resource.getLength(fSize));

  for(int i=0; i<length; i++)
  {
//   System.out.println(files[i]);
   dirEntry[i] = new DirEntry(files[i],this);

   if(type.equals("local"))
   {
    File f = new File(path+files[i]);
    if(f.isDirectory())
    {
     dirEntry[i].setDirectory();
     if(!dirEntry[i].file.endsWith("/")) dirEntry[i].file = dirEntry[i].file + "/";
    }
   }

   if(type.equals("remote"))
   {
    dirEntry[i].size = Integer.parseInt(fSize[i]);

    if(dirEntry[i].file.endsWith("/"))
    {
     dirEntry[i].setDirectory();
    }
    else
    {
     dirEntry[i].setFile();
    }
   }

  }
 }
 else {JFtp.debugWrite("Not a directory: "+path);}

// System.out.println("length: "+length+"   pos: "+pos);
 pathChanged = false;
}
 update();
}

public void update()
{
 setVisible(false);
 p.setVisible(false);

//System.out.println("pos="+pos);
for(int i=0; i<length; i++)
 {
  p.remove(dirEntry[i]);
 }

 for(int i=pos; i<pos+Settings.numFiles; i++)
 {
//System.out.print("i="+i+"   ");
  if(i < length)
  {
//   System.out.println(dirEntry[i].file);
   p.add(dirEntry[i]);
   dirEntry[i].setBounds(0,(i-pos)*24+65,getSize().width,24);
  }
 }

//System.out.println("");
// end directory init
add(p);
p.setBounds(0,0,getSize().width,getSize().height);

p.setVisible(true);
setVisible(true);
}

public void setPath(String p)
{
 File f = new File(p);
 if(f.exists())
 {
 try
 {
  path = f.getCanonicalPath();

  String c = "\\";
  char c1 = c.charAt(0);
  String d = "/";
  char d1 = d.charAt(0);
  path = path.replace(c1,d1);

  if(!path.endsWith("/")) {path = path + "/";}
 }
 catch(IOException ex) {JFtp.debugWrite("Error: can not get pathname (local)!");}

 clear();
 pathChanged = true;
 gui();
 }
 else {JFtp.debugWrite("No such path: "+p);}
}

public void setRemotePath(String p)
{

if(Settings.safeMode)
{
 FtpConnection.jcon.send("NOOP");

 try
 {
  String noop = FtpConnection.in.readLine();
  JFtp.debugWrite(noop);

  while(!noop.startsWith("200"))
  {
   noop = FtpConnection.in.readLine();
   JFtp.debugWrite(noop);
  }
 }
  catch(IOException ex) {JFtp.debugWrite("Error: No connection!");}
}

 try
 {
  FtpConnection.jcon.send("CWD "+p);

 while(true)
 {
  String tmp = FtpConnection.in.readLine();

  if(tmp.startsWith("250"))
  {
   path = p;
   if(!path.endsWith("/")) {path = path + "/";}
   JFtp.debugWrite(tmp);
   clear();
   // not implemented
   path = Resource.getCanonicalPath(p);
   if(!path.endsWith("/")) {path = path + "/";}
   pathChanged = true;
   gui();
   break;
  }
  else if(tmp.startsWith("550"))
  {
   JFtp.debugWrite(tmp);
   break;
  }
  JFtp.debugWrite(tmp);
 }

 }
 catch(IOException ex) {JFtp.debugWrite("Error: can not get pathname (remote)!");}
}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == scrollUp)
 {
  if(pos >= Settings.scrollSpeed)
  {
   pos -= Settings.scrollSpeed;
   update();
  }
 }
 if(e.getSource() == scrollDown)
 {
  if(pos+Settings.scrollSpeed < length)
  {
   pos += Settings.scrollSpeed;
   update();
  }
 }

 if(e.getSource() instanceof DirEntry)
 {
  if(type.equals("local"))
  {
   setPath(path+e.getActionCommand()+"/");
   JFtp.debugWrite("CWD "+path+" (local)");
  }
  else if(type.equals("remote"))
  {
   if(!path.equals("/") || !e.getActionCommand().equals(".."))
   {
    if(!e.getActionCommand().endsWith("/")) setRemotePath(path+e.getActionCommand()+"/");
    else setRemotePath(path+e.getActionCommand());
   }
//   JFtp.debugWrite("CWD "+path+" (remote)");
  }
 }

 if(e.getSource() == delete)
 {

  for(int i=0; i<length;i++)
  {
   if(dirEntry[i].selected)
   {
    if(type.equals("local"))
    {
     File f = new File(path+dirEntry[i].file);
//     System.out.println(path+dirEntry[i].file);
     f.delete();
    }
    if(type.equals("remote"))
    {
     FtpConnection.jcon.send("DELE "+dirEntry[i].file);
     String tmp = Resource.getLine("250");
    }
   }
  }

  if(type.equals("local")) setPath(path);
  if(type.equals("remote")) setRemotePath(path);
 }

 if(e.getSource() == rmdir)
 {
  Remover r = new Remover("Remove:",type,this);
 }

 if(e.getSource() == mkdir)
 {
  Creator c = new Creator("Create:",type,this);
 }

 if(e.getSource() == cmd)
 {
  RemoteCommand rc = new RemoteCommand();
 }

 if(e.getSource() == cd)
 {
  if(type.equals("remote")) {PathChanger pthc = new PathChanger("remote");}
  if(type.equals("local")) {PathChanger pthc = new PathChanger("local");}
 }

 if(e.getSource() == refresh)
 {
  if(type.equals("local")) setPath(path);
  if(type.equals("remote")) setRemotePath(path);
 }
}

public void clear()
{
 dirEntry = null;
 length = 1;
 files = null;
 pos = 0;
 refresh.removeActionListener(this);
 delete.removeActionListener(this);
 mkdir.removeActionListener(this);
 rmdir.removeActionListener(this);
 cd.removeActionListener(this);
 scrollUp.removeActionListener(this);
 scrollDown.removeActionListener(this);
}

private String cutPath(String s)
{
 if(s.length() > 16)
 {
  while(true)
  {
   s = Resource.cutAfter(s,'/');
   if(s.length() < 16)
   {
    StringBuffer sb = new StringBuffer(s);
    sb.insert(0,".../");
    return sb.toString();
   }
  }
 }

 return s;
}

}
