import java.awt.*;
import java.awt.event.*;

public class HImageButton extends Canvas implements MouseListener
{
 public String label = "";
 public ActionListener who = null;

 private boolean entered = false;
 private Color back = Settings.mainBack;
 private Color front = Settings.front;
 private Font font = Settings.font;
 private Image img;
 private String image = null;
 private String cmd = "default";

public HImageButton(String image, String cmd, String label, ActionListener who)
{
 this.image = image;
 this.cmd = cmd;
 this.label = label;
 this.who = who;

 img = HImage.getImage(this,image);

 addMouseListener(this);
 setVisible(true);
}

public void paint(Graphics g)
{
 g.setColor(back);
 g.fillRect(0,0,getSize().width,getSize().height);
 g.drawImage(img,2,2,this);
}

public void update(Graphics g)
{
 paint(g);
}

public void mouseClicked(MouseEvent e) {}
public void mousePressed(MouseEvent e) {}

public void mouseReleased(MouseEvent e)
{
 back = Settings.mainBack;
 who.actionPerformed(new ActionEvent(this,ActionEvent.ACTION_PERFORMED,cmd));
 repaint();
}

public void mouseEntered(MouseEvent e)
{
 entered = true;
 setCursor(new Cursor(Cursor.HAND_CURSOR));
 back = Settings.activeColor;
 repaint();
 JFtp.statusP.status(label);
}

public void mouseExited(MouseEvent e)
{
 entered = false;
 setCursor(new Cursor(Cursor.DEFAULT_CURSOR));
 back = Settings.mainBack;
 repaint();
 JFtp.statusP.status("");
}

}