import java.awt.*;
import java.awt.event.*;

public class HostList extends HFrame implements ActionListener, WindowListener
{
 private final int x = 8;

 private HTextField host[] = new HTextField[x];
 private HTextField user[] = new HTextField[x];
 private HTextField pass[] = new HTextField[x];

 private HPanel p[] = new HPanel[x];

 private HButton ok[] = new HButton[x];
 private HButton save = new HButton("Save the entire list");


public HostList()
{
 setSize(750,550);
 setLocation(50,100);
 setLayout(new GridLayout(x+1,1,5,5));

 for(int i=0; i<x; i++)
 {
  LoadSet l = new LoadSet();
  String result[] = l.loadSet("cfg/.login"+Integer.toString(i));

  host[i] = new HTextField("Host:","<none>                    ");
  user[i] = new HTextField("User:","<none>       ");
  pass[i] = new HTextField("Pass:","<not cached>   ");

  if(result != null)
  {
   host[i].setText(result[0]);
   user[i].setText(result[1]);
   pass[i].setText(result[2]);
  }

  pass[i].text.setEchoCharacter('*');

  ok[i] = new HButton("Use");
  ok[i].addActionListener(this);

  p[i] = new HPanel();
  p[i].setLayout(new FlowLayout(FlowLayout.LEFT));

  p[i].add(host[i]);
  p[i].add(user[i]);
  p[i].add(pass[i]);
  p[i].add(ok[i]);

  add(p[i]);
 }

 Panel opt = new Panel();
 opt.add(save);
 save.addActionListener(this);
 add(opt);

 addWindowListener(this);
 setVisible(true);

}

public void actionPerformed(ActionEvent e)
{
 if(e.getSource() == save)
 {
  for(int i=0; i<x; i++)
  {
   String htmp = Resource.cut(host[i].getText()," ");
   String utmp = Resource.cut(user[i].getText()," ");
   String ptmp = Resource.cut(pass[i].getText()," ");
   SaveSet s = new SaveSet("cfg/.login"+Integer.toString(i),htmp,utmp,ptmp);
  }
 }

 else
 {
  for(int i=0; i<x; i++)
  {
   if(e.getSource() == ok[i])
   {
    HostChooser.host.setText(host[i].getText());
    HostChooser.user.setText(user[i].getText());
    HostChooser.pass.setText(pass[i].getText());
    this.dispose();
   }
  }
 }
}

public void windowClosing(WindowEvent e) {this.dispose();}
public void windowClosed(WindowEvent e) {}
public void windowActivated(WindowEvent e) {}
public void windowDeactivated(WindowEvent e) {}
public void windowIconified(WindowEvent e) {}
public void windowDeiconified(WindowEvent e) {}
public void windowOpened(WindowEvent e) {}


}