import java.net.*;
import java.io.*;

/*
Basic class for getting an TCP/IP-Connection
timeout sets (as the name says) the maximum time the Thread
waits for the target host...
*/

public class JConnection implements Runnable
{
private int timeout = Resource.connectionTimeout;

private String host;
private int port;

private PrintStream out;
private DataInputStream in;
private Socket  s;
private boolean isOk = false;
private boolean established = false;
private boolean reciever = false;
private Thread runner;
private int localPort = -1;

public JConnection(String host, int port)
{
this.host = host;
this.port = port;

runner = new Thread(this);
runner.start();
}

public void run()
{
 try
 {
  s = new Socket(host, port);
  localPort = s.getLocalPort();
//  s.setSoTimeout(Resource.socketTimeout);

  out = new PrintStream(s.getOutputStream());
  in = new DataInputStream(s.getInputStream());
  isOk = true;
 }
 catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @JConnection::run"); isOk = false;}
 established = true;
}

public boolean isThere() 
{
 int cnt = 0;
 while(!established && cnt<timeout)
 {
  pause(100);
  cnt = cnt+100;
 }
 return isOk;
}

public void send(String data)
{
 try
 {
  out.println(data);
 }
 catch(Exception ex) {JFtp.debugWrite(ex+" @JConnection.send()");}
}

public PrintStream getInetOutputStream() {return out;}

public DataInputStream getInetInputStream() {return in;}

public int getLocalPort() {return localPort;}

private void pause(int time) 
{ 
try {Thread.sleep(time);} 
catch(Exception ex) {JFtp.debugWrite(ex.toString()+" @JConnection::pause");}
} 
}
